/*********************************************************************                                                                   **
**  Device:     A8107
**  File:		main.c
**  Author:		JPH
**  Target:
**  Tools:		ICE
**  Created:	2017-01-10
**  Description:
**  This file is a sample code for your reference.
**
**  Copyright (C) 2007 AMICCOM Electronics Corp.
**
**  Revision history:
**
*********************************************************************/
#define _MAIN_

#include "main.h"
#include "globalvar.h"
#include "A8107_RFLIB.h"
#include "A8107.h"
#include "Uti.h"

/*********************************************************************
**  function Declaration
*********************************************************************/
void InitTimer0(void);
void Timer0ISR (void);
void initUart0_timer2(void);
void Uart0Isr(void);
void RxPacket(void);
void Err_State(void);
void A8107_WriteFIFO(void);
void GIOPin(Uint8 src);
void UserRegister(void);
void RSSI_measurement_enable(void);
void ByteSend(Uint8 src);
Uint8 ByteRead(void);
void Send4Bit(Uint8 src);
void Direct_ByteSend(Uint8 src);

void A7196_RSSI_measurement_enable(void);
void A7196_Reset(void);
void A7196_WriteReg_Page(Uint8 addr, Uint8 wbyte, Uint8 page);
Uint8 A7196_ReadReg_Page(Uint8 addr, Uint8 page);
void A7196_WriteReg(Uint8, Uint8);
Uint8 A7196_ReadReg(Uint8);
void ByteSend(Uint8 src);
Uint8 ByteRead(void);
void A7196_WriteID(void);
void A7196_WriteFIFO(void);
void A7196_initRF(void);
void A7196_Config(void);
void A7196_Cal(void);
void A7196_RxPacket(void);
void A7196_StrobeCmd(Uint8);
void A7196_SetCH(Uint8);
void Send4Bit(Uint8 src);
void A7196_FCB(void);
void A7196_KeyData(void);

void Dynamic_Lenght_TX(Uint16 FEP);
void Dynamic_Lenght_RX(void);
Uint8 FIFO_flag = 0;
//#define IDCODE_REG 			0x06
//#define RFANALOG_REG 		0x35
const Uint8 code A7196Config[]=
{
    0x00,		//MODE_REG         0x00 
    0x62,		//MODECTRL_REG     0x01 
    0x00,		//CALIBRATION_REG  0x02 
    0x00,		//FIFO1_REG        0x03 //FIFO Len	0x3F
    0x00,		//FIFO2_REG        0x04 
    0x00,		//FIFO_REG         0x05 
    0x00,		//IDCODE_REG       0x06 
    0x00,		//RCOSC1_REG       0x07 
    0x00,		//RCOSC2_REG       0x08 
    0x0C,		//RCOSC3_REG       0x09 
    0x00,		//CKO_REG          0x0A 
    0x01,		//GIO1_REG         0x0B 
    0x01,		//GIO2_REG         0x0C 
    0x2F,		//DATARATE_REG     0x0D 
    0x5A,		//PLL1_REG         0x0E 
    0x16,		//PLL2_REG         0x0F 
    0x64,		//PLL3_REG         0x10 
    0x00,		//PLL4_REG         0x11 
    0x02,		//PLL5_REG         0x12 
    0x3C,		//CHGROUP1_REG     0x13 
    0x78,		//CHGROUP2_REG     0x14 
    0x2F,		//TX1_REG          0x15 
    0x40,		//TX2_REG          0x16 
    0x18,		//DELAY1_REG       0x17 
    0x40,		//DELAY2_REG       0x18 
    0x70,		//RX_REG           0x19 
    0xFC,		//RXGAIN1_REG      0x1A 
    0xCA,		//RXGAIN2_REG      0x1B 
    0xFC,		//RXGAIN3_REG      0x1C 
    0xCA,		//RXGAIN4_REG      0x1D 
    0x00,		//RSSI_REG         0x1E 
    0xF1,		//ADC_REG          0x1F 
    0x0C,		//CODE1_REG        0x20 
    0x0E,		//CODE2_REG        0x21 
    0x2A,		//CODE3_REG        0x22 
    0x05,		//IFCAL1_REG       0x23 
    0x51,		//IFCAL2_REG       0x24 
    0xCF,		//VCOCCAL_REG      0x25 
    0xD0,		//VCOCAL1_REG      0x26 
    0x80,		//VCOCAL2_REG      0x27 
    0xB0,		//VCODEVCAL1_REG   0x28 
    0x36,		//VCODEVCAL2_REG   0x29 
    0x00,		//DASP_REG         0x2A 
    0xFF,		//VCOMODDELAY_REG  0x2B 
    0x70,		//BATTERY_REG      0x2C 
    0x7F,		//TXTEST_REG       0x2D 
    0x57,		//RXDEM1_REG       0x2E 
    0x74,		//RXDEM2_REG       0x2F 
    0xF3,		//CPC1_REG         0x30 
    0x33,		//CPC2_REG         0x31 
    0x4D,		//CRYSTALTEST_REG  0x32 
    0x19,		//PLLTEST_REG      0x33 
    0x0A,		//VCOTEST_REG      0x34 
    0x00,		//RFANALOG_REG     0x35 
    0x00,		//KEYDATA_REG      0x36 
    0xB7,		//CHSELECT_REG     0x37 
    0x00,		//ROMP_REG         0x38 
    0x00,		//DATARATECLOCK    0x39 
    0x00,		//FCR_REG          0x3A 
    0x00,		//ARD_REG          0x3B 
    0x00,		//AFEP_REG         0x3C 
    0x00,		//FCB_REG          0x3D 
    0x00,		//KEYC_REG         0x3E 
    0x00 		//USID_REG         0x3F 
};

const Uint8 code A7196_Addr2A_Config[]=
{
    0x39, 	//page0,
    0x09, 	//page1,
    0xF0, 	//Page2,
    0x80, 	//page3,
    0x80, 	//page4,
    0x08, 	//page5,
    0x82, 	//page6,
    0xC0, 	//page7,
    0x00, 	//page8,
    0x3C, 	//page9,
    0xE8, 	//pageA,
    0x00, 	//pageB,	
};

const Uint8 code A7196_Addr38_Config[]=
{
    0x4E, 	//page0,
    0xE0, 	//page1,
    0x30, 	//page2,
    0xB4, 	//page3,
    0x20, 	//page4,
    0x20, 	//page5,
    0x00, 	//page6, /* set bit devsub=1 for FCC to reduce the occupied bandwidth.*/
    0x00, 	//page7,
    0x00, 	//page8,
};

/*********************************************************************
* main loop
*********************************************************************/
void main(void)
{
	Uint8 RSSI = 0;
	Uint8 temper = 0;
	Uint8 Channel = 0;
	Uint8 AF_H = 0;
	Uint8 AF_L = 0;
	Uint8 RX_flag = 0;
	Uint8 tmp;
	//initHW
	P0 = 0xFF;
	P1 = 0xFF;
	P3 = 0xFF;

	P0OE = 0xFB;	//GIO1 input
	P1OE = 0xFB;	//GIO2 input
	P3OE = 0xDE;
	//GPIO pull-high resistor
	P0PUN = ~0x00;
	P1PUN = ~0x00;
	P3PUN = ~0x25;
	//GPIO KEYINT Interrupt
	P0WUN = ~0x00;
	P1WUN = ~0x00;
	P3WUN = ~0x00;

	InitTimer0();
	initUart0_timer2();
	TR0=1;
	EA=1;
	//GIOPin(ON);
	Delay10ms(30);	//prevent calibration fail
	
	A7196_initRF();
	A7196_StrobeCmd(CMD_STBY);
	A7196_SetCH(10); 
	
	SCS=0;
	ByteSend(FIFO1_REG);//fifo length upto 4K bytes
	ByteSend(0x3F);	//low byte
	ByteSend(0x00);	//high byte
	SCS=1;
	
	A7196_WriteReg(GPIO1_REG, 0x01); //GIO1 WTR
	A7196_WriteReg(GPIO2_REG, 0x05); //GIO2 FSYNC
	
	A7196_WriteReg(CKO_REG, 0x8A);	//CKO RCK
	
	//Master
	if(!P3_5)
	{
		while(1)
		{
			A7196_WriteFIFO(); //write data to tx fifo
			A7196_StrobeCmd(CMD_TX); //entry tx & transmit
			while(GIO1==0);
			while(GIO1); //wait transmit completed
			
			Delay1ms(10);
		}
	}
	else
	{
		RxCnt = 0;
		Err_ByteCnt = 0;
		Err_BitCnt = 0;
		
//		A7196_WriteReg(CODE1_REG,0x1C);   //CRC enable
//		A7196_WriteReg(CODE2_REG,0x8E);   //CRC filtering enable
		
		//WOR setting
		A7196_WriteReg(RCOSC1_REG,0x09);   //sleep time = 12*32/4000
		A7196_WriteReg(RCOSC2_REG,0x13);   //active time = 20/4000
		//RC Cal
		A7196_WriteReg(0x09, 0x0C); 			//RCKS_FSYCK RCOSC_E
		A7196_WriteReg(0x02, 0x20);				//RC Oscillator calibration enable
		do 
		{
			tmp=A7196_ReadReg(0x02) & 0x20;
		}
		while(tmp);
		
		A7196_WriteReg(GPIO1_REG, 0x01); //GIO1 WTR
		A7196_WriteReg(GPIO2_REG, 0x11); //gio2	MCU wake up(TWOR)
		
		while(1)
		{
			//WOR En
			A7196_WriteReg(MODECTRL_REG,0x6A);   //WORE active time = 20/4000
			A7196_StrobeCmd(CMD_SLEEP);
			while(~GIO2); //wait receive completed

			Delay1ms(1);
			A7196_RxPacket();
		}
	}
}

/************************************************************************
** Direct ByteSend
************************************************************************/
void Direct_ByteSend(Uint8 src)
{
    Uint8 i;

    for(i = 0; i < 8; i++)
    {
        if(src & 0x80)
            GIO2 = 1;
        else
            GIO2 = 0;

				_nop_();
        SCK = 1;
        _nop_();
        SCK = 0;
        src = src << 1;
    }
}

/************************************************************************
**  ByteSend
************************************************************************/
void ByteSend(Uint8 src)
{
    Uint8 i;

    for(i = 0; i < 8; i++)
    {
        if(src & 0x80)
            SDIO = 1;
        else
            SDIO = 0;
		
				_nop_();
        SCK = 1;
        _nop_();
        SCK = 0;
        src = src << 1;
    }
}

/************************************************************************
**  ByteRead
************************************************************************/
Uint8 ByteRead(void)
{
	Uint8 i,tmp;

    SDIO = 1; //sdio pull high
    for(i = 0; i < 8; i++)
    {
        if(SDIO)
            tmp = (tmp << 1) | 0x01;
        else
            tmp = tmp << 1;

        SCK = 1;
        _nop_();
        SCK = 0;
    }
    return tmp;
}

/*********************************************************************
** A7196 SetCH
*********************************************************************/
void A7196_SetCH(Uint8 ch)
{
    A7196_WriteReg(PLL1_REG, ch); //RF freq = RFbase + (CH_Step * ch)
}

/*********************************************************************
** A7196 initRF
*********************************************************************/
void A7196_initRF(void)
{
    //init io pin
    SCS = 1;
    SCK = 0;
    SDIO = 1;
    CKO = 1;
    GIO1 = 1;
    GIO2 = 1;

    A7196_Reset(); //reset A7105 RF chip
    A7196_WriteID(); //write ID code
    A7196_Config(); //config A7105 chip
    A7196_Cal(); //calibration IF,VCO,VCOC
}

/************************************************************************
**  Send4Bit
************************************************************************/
void Send4Bit(Uint8 src)
{
    Uint8 i;

    for(i = 0; i < 4; i++)
    {
        if(src & 0x80)
            SDIO = 1;
        else
            SDIO = 0;

		_nop_();
        SCK = 1;
        _nop_();
        SCK = 0;
        src = src << 1;
    }
}

/************************************************************************
**  init Timer0
************************************************************************/
void InitTimer0(void)
{
    TR0 = 0;
    TMOD =(TMOD & 0xF0)|0x01; //timer0 mode=1
    TH0 = (65536-t0hrel)>>8; // Reload Timer0 high byte,low byte
    TL0 = 65536-t0hrel;
    TF0 = 0; // Clear any pending Timer0 interrupts
    ET0 = 1; // Enable Timer0 interrupt
}

/************************************************************************
**  Timer0ISR
************************************************************************/
void Timer0ISR (void) interrupt 1
{
    TF0 = 0; // Clear Timer0 interrupt
    TH0 = (65536-t0hrel)>>8; // Reload Timer0 high byte,low byte
    TL0 = 65536-t0hrel;

    timer++;
    if (timer == TIMEOUT)
        TimeoutFlag=1;

    TimerCnt0++;
    if (TimerCnt0 == 1000)//500)
    {
        TimerCnt0=0;
        CmdBuf[0]=0xF1;

        memcpy(&CmdBuf[1], &RxCnt, 2);
        memcpy(&CmdBuf[3], &SubRxCnt, 1);
				memcpy(&CmdBuf[4], &LossCnt, 1);
        memcpy(&CmdBuf[7], &Err_BitCnt, 4);
        memcpy(&CmdBuf[11], &Err_Frame, 1);

        UartSendCnt=12;
				Uartptr=&CmdBuf[0];
        SBUF=CmdBuf[0];
    }
}

/************************************************************************
**  initUart0_timer2()
************************************************************************/
void initUart0_timer2(void)
{
	IOSEL |= 0x01;//enable BBIOS + UART
	PCON = 0x00;
    SCON=0x40;
	T2CON=0x30;
	RCAP2H = BaudRate38400 / 256;
    RCAP2L = BaudRate38400 % 256;
    TR2=1;
    REN = 1;
    ES=1;//enable uart0 interrupt
}

/************************************************************************
**  Uart0 ISR
************************************************************************/
void Uart0Isr(void) interrupt 4 using 3
{
    if (TI)
    {
        TI=0;
        UartSendCnt--;
        if(UartSendCnt !=0)
        {
            Uartptr++;
            SBUF = *Uartptr;
        }
    }

    if (RI)
    {
        RI=0;
    }
}

/*********************************************************************
** RxPacket
*********************************************************************/
void RxPacket(void)
{
	Uint8 i,recv,tmp;
	Uint8 err;
//	if(!P3_5)
//		FIFO_flag = 1;
	FIFO_flag = 1;
	err=0;
	RxCnt++;
	for(i=0; i <64; i++)
	{
		recv = A8107_ReadReg(RXDATA_REG + i);
		tmpbuf[i]=recv;
		if((recv ^ PN9_Tab[i])!=0)
		{
				Err_ByteCnt++;
				tmp = recv ^ PN9_Tab[i];
				Err_BitCnt += (BitCount_Tab[tmp>>4] + BitCount_Tab[tmp & 0x0F]);

				err=1;
		}
	}

	if (err)//packet error
		LossCnt++;
}

/*********************************************************************
** Err_State
*********************************************************************/
void Err_State(void)
{
    //ERR display
    //Error Proc...
    //...
    while(1);
}

/************************************************************************
**  A8107_WriteFIFO
************************************************************************/
void A8107_WriteFIFO(void)
{
    Uint8 i;
		
    for(i=0; i<64; i++)
        A8107_WriteReg(TXDATA_REG + i , PN9_Tab[i]);
}

/************************************************************************
** GIOPin
************************************************************************/
void GIOPin(Uint8 src)
{
    if(src)
    	IOSEL |= 0x00;//0x08
    else
       	IOSEL &= 0xF7;
}

/************************************************************************
** UserRegister
************************************************************************/
void UserRegister(void)
{	
	Uint8 i;

    for (i=0; i<4; i++)
        A8107_WriteReg(ID_REG + i, ID_Tab[i]);//ID Bytes

	A8107_WriteReg(MODE_REG, 0x00);//Mode register
	A8107_WriteReg(FIFO1_REG, 63);//fifo length
	A8107_WriteReg(CKO_REG, 0x00);//CKO register
	A8107_WriteReg(GIO1_REG, 0x40);//GIO1 register
	A8107_WriteReg(GIO2_REG, 0x1C);//GIO2 register
	A8107_WriteReg(MODECTRL_REG, 0x62);//ModeControl register
	A8107_WriteReg(PLL1_REG, 100);//channel	frequency
	A8107_WriteReg(TX1_REG, 0x5E);//TX1 register
   	A8107_WriteReg(TXTEST_REG, 0x07);//TX power 
    A8107_WriteReg(CODE1_REG, 0x00);//Code1 register
   	A8107_WriteReg(RSSI_REG, 0x00);//RSSI register
	A8107_WriteReg(ADC_REG, 0xEA);//ADC register
	A8107_WriteReg(BATTERY_REG, 0x26);//Battery register
	A8107_WriteReg(INC_REG, 0x72);//INC register
    A8107_WriteReg(PWRCTL1_REG, 0x50);//Power control I register
}

/*********************************************************************
** RSSI_measurement_enable
*********************************************************************/
void RSSI_measurement_enable(void)
{
	Uint8 tmp;

	A8107_WriteReg(GIO2_REG, 0x04); //GIO2 as Rx sync signal
	 
	StrobeCmd(CMD_RX); //entry Rx mode
	while(GIO2==0) //Stay in RX mode until receiving ID code(sync ok)
	{
		tmp= A8107_ReadReg(RSSI_REG);	//read RSSI value(environment RSSI)
	}
	tmp= A8107_ReadReg(RSSI_REG);		//read RSSI value(wanted signal RSSI)
}

/*********************************************************************
** CEFCC_Test
*********************************************************************/
void CEFCC_Test(void)
{
    A8107_WriteReg(TXTEST_REG, 0x07);//TX power

    while(1)
    {
    	//for TX burst
		SetCH(4); //freq 2402MHz
		A8107_WriteReg(MODECTRL_REG, 0x62);//fifo mode
    	StrobeCmd(CMD_TX);
		Delay10us(1);
    	while(GIO1);
    	
    	//for RX state
		/*
		SetCH(80);  
		A8107_WriteReg(MODECTRL_REG, 0x60);//direct mode
    	StrobeCmd(CMD_RX);
		while(1);
		*/

		//for TX carrier
        /*
        SetCH(4); //freq 2402MHz
        A8107_WriteReg(MODECTRL_REG, 0x60); //direct mode
        A8107_WriteReg(TX1_REG, 0x06); //TME off
    	StrobeCmd(CMD_TX);
    	while(1);
        */
    }
 }

 /************************************************************************
**  Reset_RF
************************************************************************/
void A7196_Reset(void)
{
    A7196_WriteReg(MODE_REG, 0x00); //reset RF chip
}

/************************************************************************
**  WriteID
************************************************************************/
void A7196_WriteID(void)
{
    Uint8 i;
    Uint8 d1,d2,d3,d4,d5,d6,d7,d8;
    Uint8 addr;
    
    addr = IDCODE_REG; //send address 0x06, bit cmd=0, r/w=0
    SCS = 0;
    ByteSend(addr);
    for (i=0; i < 8; i++)
    	ByteSend(ID_Tab[i]);
    SCS = 1;
    
    addr = IDCODE_REG | 0x40; //send address 0x06, bit cmd=0, r/w=1
    SCS=0;
    ByteSend(addr);
    d1=ByteRead();
    d2=ByteRead();
    d3=ByteRead();
    d4=ByteRead();
    d5=ByteRead();
    d6=ByteRead();
    d7=ByteRead();
    d8=ByteRead();
    SCS=1;
}

/*********************************************************************
** A7196_ReadReg_Page
*********************************************************************/
Uint8 A7196_ReadReg_Page(Uint8 addr, Uint8 page)
{
    Uint8 tmp;

    A7196_WriteReg(RFANALOG_REG, (A7196Config[RFANALOG_REG]&0x0F) | PageTab[page]);//page select
    tmp = A7196_ReadReg(addr);
    return tmp;
}

/*********************************************************************
** A7196_WriteReg_Page
*********************************************************************/
void A7196_WriteReg_Page(Uint8 addr, Uint8 wbyte, Uint8 page)
{
    A7196_WriteReg(RFANALOG_REG, (A7196Config[RFANALOG_REG]&0x0F) | PageTab[page]);//page select
    A7196_WriteReg(addr, wbyte);
}

/************************************************************************
**  A7196_WriteReg
************************************************************************/
void A7196_WriteReg(Uint8 addr, Uint8 dataByte)
{
    Uint8 i;

    SCS = 0;

    addr |= 0x00; //bit cmd=0,r/w=0
    for(i = 0; i < 8; i++)
    {
        if(addr & 0x80)
            SDIO = 1;
        else
            SDIO = 0;

        SCK = 1;
        _nop_();
        SCK = 0;
        addr = addr << 1;
    }
    _nop_();

    //send data byte
    for(i = 0; i < 8; i++)
    {
        if(dataByte & 0x80)
            SDIO = 1;
        else
            SDIO = 0;

        SCK = 1;
        _nop_();
        SCK = 0;
        dataByte = dataByte<< 1;
    }

    SCS = 1;
}

/************************************************************************
**  A7196_ReadReg
************************************************************************/
Uint8 A7196_ReadReg(Uint8 addr)
{
    Uint8 i;
    Uint8 tmp;

    SCS = 0;
    addr |= 0x40; //bit cmd=0,r/w=1
    for(i = 0; i < 8; i++)
    {
        if(addr & 0x80)
            SDIO = 1;
        else
            SDIO = 0;

			    	_nop_();
        SCK = 1;
        _nop_();
        SCK = 0;

        addr = addr << 1;
    }

    _nop_();
    SDIO = 1;

    //read data
    for(i = 0; i < 8; i++)
    {
        if(SDIO)
            tmp = (tmp << 1) | 0x01;
        else
            tmp = tmp << 1;

        SCK = 1;
        _nop_();
        SCK = 0;
    }
    SCS = 1;
    return tmp;
}

/*********************************************************************
** A7196_WriteFIFO
*********************************************************************/
void A7196_WriteFIFO(void)
{
    Uint8 i;
		Uint8 cmd;
		
//		A7196_StrobeCmd(CMD_TFR);
		cmd = FIFO_REG; //send address 0x05, bit cmd=0, r/w=0
		SCS=0;
		ByteSend(cmd);
		for(i=0; i <64; i++)
				ByteSend(PN9_Tab[i]);
//		ByteSend(0xA6);
		SCS=1;
}

/*********************************************************************
** Strobe Command
*********************************************************************/
void A7196_StrobeCmd(Uint8 cmd)
{
		SCS = 0;
		ByteSend(cmd);
		SCS = 1;
}

/*********************************************************************
** A7196 RxPacket
*********************************************************************/
void A7196_RxPacket(void)
{
    Uint8 i;
    Uint8 recv;
    Uint8 tmp;
    Uint8 cmd;
		
    RxCnt++;
		recv = 0;
		memset(tmpbuf,0,sizeof(tmpbuf));
    cmd = FIFO_REG | 0x40; //address 0x05, bit cmd=0, r/w=1
    
    SCS=0;
    ByteSend(cmd);
    for(i=0; i <64; i++)
    {
				recv = ByteRead();
				tmpbuf[i]=recv;
				if((recv ^ PN9_Tab[i])!=0)
        {
            tmp = recv ^ PN9_Tab[i];
            Err_BitCnt += (BitCount_Tab[tmp>>4] + BitCount_Tab[tmp & 0x0F]);
        }
    }
    SCS=1;
}

/*********************************************************************
** A7196 CHGroupCal
*********************************************************************/
void A7196_CHGroupCal(Uint8 ch)
{
    Uint8 tmp;
    Uint8 vb,vbcf,vcb,vccf,adag;
    Uint8 deva,adev;

		  A7196_WriteReg(PLL1_REG, ch);
		  A7196_WriteReg(CALIBRATION_REG, 0x1C);
		  do{
		  		  tmp = A7196_ReadReg(CALIBRATION_REG)&0x1C;
		  }while (tmp);

    //for check
    tmp = A7196_ReadReg(VCOCCAL_REG);
    vcb = tmp & 0x0F;
    vccf = (tmp>>4) & 0x01;
    
    tmp = A7196_ReadReg(VCOCAL1_REG);
		  vb = tmp & 0x07;
		  vbcf = (tmp >>3) & 0x01;
	
		  tmp = A7196_ReadReg(VCOCAL2_REG);
		  adag = tmp;

		  tmp = A7196_ReadReg(VCODEVCAL1_REG);
		  deva = tmp;

		  tmp = A7196_ReadReg(VCODEVCAL2_REG);
		  adev = tmp;

		  if(vbcf||vccf)
	   		  Err_State();//error   
}

/*********************************************************************
** calibration
*********************************************************************/
void A7196_Cal(void)
{
		Uint8 tmp,tmp1;
		Uint8 rhc,rlc,fb,fbcf,fcd,rcrs,rcts;
		Uint16 rct;

 		A7196_StrobeCmd(CMD_PLL); //calibration @PLL state

		//IF,RSSI,RC procedure
		A7196_WriteReg(CALIBRATION_REG, 0x23);
		do{
				  tmp = A7196_ReadReg(CALIBRATION_REG)&0x23;
		}while(tmp);	

		//calibration VBC,VDC procedure
		A7196_CHGroupCal(30); //calibrate channel group Bank I
		A7196_CHGroupCal(90); //calibrate channel group Bank II
		A7196_CHGroupCal(150); //calibrate channel group Bank III
		A7196_StrobeCmd(CMD_STBY); //return to STBY state

		tmp = A7196_ReadReg(IFCAL1_REG);
		fb = tmp & 0x0F;
		fbcf = (tmp>>4) & 0x01;
	
		fcd = A7196_ReadReg(IFCAL2_REG)&0x1F;	
		
		rhc = A7196_ReadReg(RXGAIN2_REG);
		rlc = A7196_ReadReg(RXGAIN3_REG);
		
		tmp = A7196_ReadReg_Page(0x2A, 8);
		rcrs = tmp & 0x0F;
		tmp1 = (tmp &0xF0) >> 4;
		
		tmp = A7196_ReadReg_Page(0x2A, 9);
		rcts = (tmp & 0x03)<<4 | tmp1;
		tmp1 = (tmp & 0xF0)>>4;
		
		tmp = A7196_ReadReg_Page(0x2A, 10);
		rct = tmp | ((tmp1)*256);		
		
		if(fbcf)
				Err_State();
}

/*********************************************************************
** A7196_Config
*********************************************************************/
void A7196_Config(void)
{
	Uint8 i;

    //0x00 mode register, for reset
    //0x05 fifo data register
    //0x06 id code register
    //0x3F USID register, read only
    //0x36 key data, 16 bytes
    //0x3D FCB register,4 bytes

    for(i=0x01; i<=0x02; i++)
				    A7196_WriteReg(i, A7196Config[i]);
	   
		  SCS = 0;
		  ByteSend(0x03);
		  ByteSend(0x3F);
		  ByteSend(0x00);
		  SCS = 1;
	    
	   A7196_WriteReg(0x04, A7196Config[0x04]);
	
		  for(i=0x07; i<=0x29; i++)
				    A7196_WriteReg(i, A7196Config[i]);

		  for(i=0; i<=11; i++)//0x2A DAS
				    A7196_WriteReg_Page(0x2A, A7196_Addr2A_Config[i], i);
		
		  for (i=0x2B; i<=0x35; i++)
				    A7196_WriteReg(i, A7196Config[i]);
	
		  A7196_KeyData();
	
		  A7196_WriteReg(0x37, A7196Config[0x37]);

	  	for (i=0; i<=8; i++)//0x38 ROM
				  A7196_WriteReg_Page(0x38, A7196_Addr38_Config[i], i);

		  for(i=0x39; i<=0x3C; i++)
				    A7196_WriteReg(i, A7196Config[i]);
	
		  A7196_FCB();

		  A7196_WriteReg(0x3E, A7196Config[0x3E]);
		  A7196_WriteReg(0x3F, A7196Config[0x3F]);
}                      
                                                
/*********************************************************************
** Write A7196_KeyData                                                   
*********************************************************************/ 
void A7196_KeyData(void)
{
    Uint8 i;
    Uint8 addr;

    addr = KEYDATA_REG; //send address 0x06, bit cmd=0, r/w=0
    SCS = 0;
    ByteSend(addr);
    for (i=0; i < 16; i++)
        ByteSend(KeyData_Tab[i]);
    SCS = 1;
}

/*********************************************************************
** Write A7196_FCB                                                   
*********************************************************************/ 
void A7196_FCB(void)
{
    Uint8 i;
    Uint8 addr;

    addr = FCB_REG; //send address 0x06, bit cmd=0, r/w=0
    SCS = 0;
    ByteSend(addr);
    for (i=0; i < 20; i++)
			     ByteSend(FCB_Tab[i]);
    SCS = 1;
}

/*********************************************************************
** A7196 RSSI_measurement_enable
*********************************************************************/
void A7196_RSSI_measurement_enable(void)
{
    Uint8 tmp;
    
    A7196_WriteReg(GIO1_REG, 0x01);	//GIO1 as WTR
    A7196_WriteReg(GIO2_REG, 0x05);	//GIO1 as Rx Sync Signal
    
    A7196_WriteReg(MODECTRL_REG, A7196Config[MODECTRL_REG] | 0x40);	//ARSSI=1
    A7196_WriteReg(ADC_REG, A7196Config[ADC_REG]|0x01);	// CDM Enable
    
    A7196_StrobeCmd(CMD_RX);	//entry Rx mode
    
    while(GIO2==0)		//Stay in RX mode until receiving ID code(sync ok)
    {
        tmp= A7196_ReadReg(RSSI_REG);	//read RSSI value(environment RSSI)
    }
    
    tmp= A7196_ReadReg(RSSI_REG);		//read RSSI value(wanted signal RSSI)
}
/*********************************************************************
** Dynamic_Lenght_TX (option)
*********************************************************************/
//void Dynamic_Lenght_TX(Uint16 FEP)
//{
//		Uint8 n,cmd;
//		Uint8	FEP_H,FEP_L;
//		Uint16 i;
//		
//		FEP=(FEP-1)&0x1FF;
//		FEP_H=(FEP&0x100)>>8;
//		FEP_L=FEP&0xFF;
//		
//		//Setting FIFO Length
//		SCS=0;
//		ByteSend(FIFO1_REG);//fifo length upto 4K bytes
//		ByteSend(FEP_L);	//low byte
//		ByteSend(FEP_H);	//high byte
//		SCS=1;
//		
//		//Check GPIO Pin
//		A7196_WriteReg(GIO1_REG, 0x3D);	//FMTDO
//		A7196_WriteReg(GIO2_REG, 0x05);	//EOAC
//		A7196_WriteReg(CKO_REG, 0x02);	//DCK
//		
//		//enable Dynamic Length
//		A7196_WriteReg(CODE2_REG, 0x4E);	//EDRL=1
//		
//		n=0;
//		
//		cmd = FIFO_REG; //send address 0x05, bit cmd=0, r/w=0
//    SCS=0;
//		ByteSend(cmd);
//		for(i=0; i<(FEP+1); i++)
//		{
//			ByteSend(n);
//			n++;
//		}
//		SCS=1;
//		
//		A7196_StrobeCmd(CMD_TX); //entry tx
//		Delay10us(1);
//		while(~GIO2); 
//		while(GIO2); //wait transmit completed
//		
//		Delay10ms(1);
//}
/*********************************************************************
** Dynamic_Lenght_RX (option)
*********************************************************************/
//void Dynamic_Lenght_RX(void)
//{
//		Uint8 n,cmd,recv,tmp;
//		Uint8	LENF_H,LENF_L;
//		Uint16 i,dynamic_Length;
//	
//		//Check GPIO Pin
//		A7196_WriteReg(GIO1_REG, 0x05);	//Fsync
//		A7196_WriteReg(GIO2_REG, 0x1D);	//TRXD
//		A7196_WriteReg(CKO_REG, 0x02);	//DCK
//	
//		//enable Dynamic Length
//		A7196_WriteReg(CODE2_REG, 0x4E);	//EDRL=1
//	
//		n=0;
//		Err_BitCnt=0;
//		Err_ByteCnt=0;
//	
//		A7196_StrobeCmd(CMD_RX); //entry rx
//		Delay10us(1);
//		while(~GIO1); 
//		while(GIO1); //wait receive completed
//	
//		RxCnt++;
//		
//		//Read FIFO Length from TX packet
//		SCS=0;
//		ByteSend(FIFO1_REG|0x40);//fifo length upto 4K bytes
//		LENF_L=ByteRead();	//low byte
//		LENF_H=ByteRead();	//high byte
//		SCS=1;
//		
//		dynamic_Length=((LENF_H<<8)|LENF_L)+1;
//		if(dynamic_Length>=512)
//			dynamic_Length=512;
//	
//		cmd = FIFO_REG | 0x40; //address 0x05, bit cmd=0, r/w=1
//    SCS=0;
//    ByteSend(cmd);
//		for(i=0;i<dynamic_Length;i++)
//				tmpbuf1[i]=ByteRead();
//		SCS=1;
//		
//		
//		//for check
//		for(i=0;i<dynamic_Length;i++)
//		{
//				recv=tmpbuf1[i];
//				tmp=recv^n;
//				if(tmp!=0)
//				{
//					Err_ByteCnt++;
//					Err_BitCnt+=(BitCount_Tab[tmp>>4] + BitCount_Tab[tmp & 0x0F]);
//				}
//				n++;
//		}
//}